Search Results for

Show / Hide Table of Contents

# Interface IAutocomplete

Renders an overlay on another view at a given point that allows selecting from a range of 'autocomplete' options.

###### Namespace: Terminal.Gui

###### Assembly: Terminal.Gui.dll

##### Syntax

    public interface IAutocomplete

### Properties

#### AllSuggestions

The full set of all strings that can be suggested.

##### Declaration

    List<string> AllSuggestions { get; set; }

##### Property Value

Type | Description
--- | ---
System.Collections.Generic.List<System.String> |

#### CloseKey

The key that the user can press to close the currently popped autocomplete menu

##### Declaration

    Key CloseKey { get; set; }

##### Property Value

Type | Description
--- | ---
Key |

#### ColorScheme

The colors to use to render the overlay. Accessing this property before the Application has been initialized will cause an error

##### Declaration

    ColorScheme ColorScheme { get; set; }

##### Property Value

Type | Description
--- | ---
ColorScheme |

#### HostControl

The host control that will use autocomplete.

##### Declaration

    View HostControl { get; set; }

##### Property Value

Type | Description
--- | ---
View |

#### MaxHeight

The maximum number of visible rows in the autocomplete dropdown to render

##### Declaration

    int MaxHeight { get; set; }

##### Property Value

Type | Description
--- | ---
System.Int32 |

#### MaxWidth

The maximum width of the autocomplete dropdown

##### Declaration

    int MaxWidth { get; set; }

##### Property Value

Type | Description
--- | ---
System.Int32 |

#### PopupInsideContainer

Gets or sets where the popup will be displayed.

##### Declaration

    bool PopupInsideContainer { get; set; }

##### Property Value

Type | Description
--- | ---
System.Boolean |

#### Reopen

The key that the user can press to reopen the currently popped autocomplete menu

##### Declaration

    Key Reopen { get; set; }

##### Property Value

Type | Description
--- | ---
Key |

#### SelectedIdx

The currently selected index into Suggestions that the user has highlighted

##### Declaration

    int SelectedIdx { get; set; }

##### Property Value

Type | Description
--- | ---
System.Int32 |

#### SelectionKey

The key that the user must press to accept the currently selected autocomplete suggestion

##### Declaration

    Key SelectionKey { get; set; }

##### Property Value

Type | Description
--- | ---
Key |

#### Suggestions

The strings that form the current list of suggestions to render based on what the user has typed so far.

##### Declaration

    ReadOnlyCollection<string> Suggestions { get; set; }

##### Property Value

Type | Description
--- | ---
System.Collections.ObjectModel.ReadOnlyCollection<System.String> |

#### Visible

True if the autocomplete should be considered open and visible

##### Declaration

    bool Visible { get; set; }

##### Property Value

Type | Description
--- | ---
System.Boolean |

### Methods

#### ClearSuggestions()

Clears Suggestions

##### Declaration

    void ClearSuggestions()

#### GenerateSuggestions()

Populates Suggestions with all strings in AllSuggestions that match with the current cursor position/text in the HostControl.

##### Declaration

    void GenerateSuggestions()

#### MouseEvent(MouseEvent, Boolean)

Handle mouse events before HostControl e.g. to make mouse events like report/click apply to the autocomplete control instead of changing the cursor position in the underlying text view.

##### Declaration

    bool MouseEvent(MouseEvent me, bool fromHost = false)

##### Parameters

Type | Name | Description
--- | --- | ---
MouseEvent | me | The mouse event.
System.Boolean | fromHost | If was called from the popup or from the host.

##### Returns

Type | Description
--- | ---
System.Boolean | `true`if the mouse can be handled `false`otherwise.

#### ProcessKey(KeyEvent)

Handle key events before HostControl e.g. to make key events like up/down apply to the autocomplete control instead of changing the cursor position in the underlying text view.

##### Declaration

    bool ProcessKey(KeyEvent kb)

##### Parameters

Type | Name | Description
--- | --- | ---
KeyEvent | kb | The key event.

##### Returns

Type | Description
--- | ---
System.Boolean | `true`if the key can be handled `false`otherwise.

#### RenderOverlay(Point)

Renders the autocomplete dialog inside the given HostControl at the given point.

##### Declaration

    void RenderOverlay(Point renderAt)

##### Parameters

Type | Name | Description
--- | --- | ---
Point | renderAt |